//
//  HelloWorldLayer.m
//  MTOSC
//
//  Created by Dustin O'Connor on 5/28/10.
//  Copyright d0cut0uch 2010. All rights reserved.
//

// Import the interfaces
#import "mtosc.h"

#import "CCTouchDelegateProtocol.h"

#import "BBOSCArgument.h"
#import "BBOSCListener.h"
#import "BBOSCDispatcher.h"
#import "BBOSCDataUtilities.h"
#import "BBOSCMessage.h"
#import "BBOSCBundle.h"
#import "BBOSCDecoder.h"
#import "BBOSCSender.h"
#import "BBOSCAddress.h"

// HelloWorld implementation
@implementation multiTouch

@synthesize emitter,ax,ay,emitter2,emitter3,emitter4,emitter5, label, result;
@synthesize oscListener;
@synthesize oscSender;

@synthesize touch1,touch2,touch3,touch4,touch5,touched,touchMe;

+(id) scene
{
	// 'scene' is an autorelease object.
	CCScene *scene = [CCScene node];
	
	// 'layer' is an autorelease object.
	multiTouch *layer = [multiTouch node];
	
	// add layer as a child to scene
	[scene addChild: layer];
	
	// return the scene
	return scene;
}

// on "init" you need to initialize your instance
-(id) init
{
	// always call "super" init
	// Apple recommends to re-assign "self" with the "super" return value
	if( (self=[super initWithColor:ccc4(0,0,0,255)] )) {		
		// create and initialize a Label
		
		self.label = [CCLabel labelWithString:@"3Tap2Enter[ip]" fontName:@"helvetica neue" fontSize:24];
		[self.label setColor:ccc3(100,100,100)];	
		
		
		CGSize size = [[CCDirector sharedDirector] winSize];
		
			// position the label on the center of the screen
		self.label.position =  ccp( size.width /2 , size.height/2+300 );
		
			// add the label as a child to this Layer
			//[self addChild:self.label];
		

		
		self.isTouchEnabled = YES;
		
		self.isAccelerometerEnabled = YES;

		
	}
	return self;
}


-(void)specifyStartLevel {
    text = [[UITextField alloc] initWithFrame:CGRectMake(60, 165, 200, 90)];
    [text setDelegate:self];
    [text setText:@""];
    [text setTextColor: [UIColor colorWithRed:255 green:255 blue:255 alpha:1.0]];
    [[[[CCDirector sharedDirector] openGLView] window] addSubview:text];
    [text becomeFirstResponder];
}

-(BOOL)textFieldShouldReturn:(UITextField *)textField {
    [text resignFirstResponder];
    return YES;
}
-(void)textFieldDidEndEditing: (UITextField *)textField {
	int count = 0;
	
	if(textField == text) {
		
	[self removeChild:self.label cleanup:YES];
        [text endEditing:YES];
        [text removeFromSuperview];
        self.result = text.text;
		
		self.label = [CCLabel labelWithString:self.result fontName:@"helvetica neue" fontSize:24];
		[self.label setColor:ccc3(100,100,100)];	
		
		
		CGSize size = [[CCDirector sharedDirector] winSize];
		
			// position the label on the center of the screen
		self.label.position =  ccp( size.width /2 , size.height/2+300 );
		
			// add the label as a child to this Layer
		[self addChild: label];
		
			[self setOscSender:[BBOSCSender senderWithDestinationHostName:self.result portNumber:6666]];
        NSLog([NSString stringWithFormat:@"entered: %@", result]);


    }
}


-(void) toggleCallback: (id) sender
{
	if( emitter.positionType == kCCPositionTypeGrouped )
		emitter.positionType = kCCPositionTypeFree;
	else
		emitter.positionType = kCCPositionTypeGrouped;


	if( emitter2.positionType == kCCPositionTypeGrouped )
		emitter2.positionType = kCCPositionTypeFree;
	else
		emitter2.positionType = kCCPositionTypeGrouped;
	
	if( emitter3.positionType == kCCPositionTypeGrouped )
		emitter3.positionType = kCCPositionTypeFree;
	else
		emitter3.positionType = kCCPositionTypeGrouped;	
	
	if( emitter4.positionType == kCCPositionTypeGrouped )
		emitter4.positionType = kCCPositionTypeFree;
	else
		emitter4.positionType = kCCPositionTypeGrouped;	
	
	if( emitter5.positionType == kCCPositionTypeGrouped )
		emitter5.positionType = kCCPositionTypeFree;
	else
		emitter5.positionType = kCCPositionTypeGrouped;	


}
-(void) restartCallback: (id) sender
{
	
	[emitter resetSystem];
	
	[emitter stopSystem];
	
	[emitter2 resetSystem];
	
	[emitter2 stopSystem];
	
	[emitter3 resetSystem];
	
	[emitter3 stopSystem];
	
	[emitter4 resetSystem];
	
	[emitter4 stopSystem];
	
	[emitter5 resetSystem];
	
	[emitter5 stopSystem];
	
}


-(void)ccTouchesBegan:(NSSet *)touches withEvent:(UIEvent *)event
{
	
	NSUInteger numTaps = [[touches anyObject] tapCount];
	
	
	if(numTaps >= 3) {
		NSLog(@"%d taps",numTaps); 
		 [self specifyStartLevel];
}
	else {
		NSLog(@"%d taps",numTaps); 
	}
	
	NSUInteger touchCount = 0;
	for (UITouch *touch in touches) {
		touchCount++;  
	}	
	
	
}





-(void)ccTouchesMoved:(NSSet *)touches withEvent:(UIEvent *)event
{
	NSUInteger touchCount = 0;
	
	NSSet *allTouches = [event allTouches];
	
	for (UITouch *touch in touches) {
		touchCount++;}
	
	
	touch1 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/1/"]];
	touch2 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/2/"]];
	touch3 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/3/"]];
	touch4 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/4/"]];
	touch5 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/5/"]];
	


	
	switch ([touches count])
	{
		case 1: {
			UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
			CGPoint location = [t1 locationInView: [t1 view]];
			 CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
			CGPoint end = [t1 previousLocationInView:[t1 view]];
			end = [[CCDirector sharedDirector] convertToGL:end];

			[self removeChild:background cleanup:YES];
			background = nil;
			self.emitter.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter = [CCPointParticleSystem particleWithFile:@"t1.plist"];
			self.emitter.duration = .1;
			self.emitter.position = ccp(start.x,start.y);
				//[self addChild: emitter z:0];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.y]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.y]];
			[[self oscSender] sendOSCPacket:touch1];
	
		
		} break;
			
		case 2: {
			
			[self removeChild:background cleanup:YES];
			background = nil;
			
			
			UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
			CGPoint location = [t1 locationInView: [t1 view]];
			CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
			CGPoint end = [t1 previousLocationInView:[t1 view]];
			end = [[CCDirector sharedDirector] convertToGL:end];
			self.emitter.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter = [CCPointParticleSystem particleWithFile:@"t1.plist"];
			self.emitter.duration = .1;
			self.emitter.position = ccp(start.x,start.y);
				//[self addChild: emitter z:0];
		

			
			UITouch *t2 = [[allTouches allObjects]objectAtIndex:1];
			CGPoint location2 = [t2 locationInView: [t2 view]];
			CGPoint start2 = [[CCDirector sharedDirector] convertToGL:location2];
			CGPoint end2 = [t2 previousLocationInView:[t2 view]];
			end2 = [[CCDirector sharedDirector] convertToGL:end2];
			self.emitter2.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter2 = [CCPointParticleSystem particleWithFile:@"t2.plist"];
			self.emitter2.duration = .1;
			self.emitter2.position = ccp(start2.x,start2.y);
				//[self addChild: emitter2 z:0];
			
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.y]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.y]];
			[[self oscSender] sendOSCPacket:touch1];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.y]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.y]];
			[[self oscSender] sendOSCPacket:touch2];
		
		
		
		} break;
			
		case 3: {
			
			[self removeChild:background cleanup:YES];
			background = nil;
			
			
			UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
			CGPoint location = [t1 locationInView: [t1 view]];
			CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
			CGPoint end = [t1 previousLocationInView:[t1 view]];
			end = [[CCDirector sharedDirector] convertToGL:end];
			self.emitter.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter = [CCPointParticleSystem particleWithFile:@"t1.plist"];
			self.emitter.duration = .1;
			self.emitter.position = ccp(start.x,start.y);
				//[self addChild: emitter z:0];
			
			
			
			UITouch *t2 = [[allTouches allObjects]objectAtIndex:1];
			CGPoint location2 = [t2 locationInView: [t2 view]];
			CGPoint start2 = [[CCDirector sharedDirector] convertToGL:location2];
			CGPoint end2 = [t2 previousLocationInView:[t2 view]];
			end2 = [[CCDirector sharedDirector] convertToGL:end2];
			self.emitter2.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter2 = [CCPointParticleSystem particleWithFile:@"t2.plist"];
			self.emitter2.duration =.1;
			self.emitter2.position = ccp(start2.x,start2.y);
				//[self addChild: emitter2 z:0];
			
			
			UITouch *t3 = [[allTouches allObjects]objectAtIndex:2];
			CGPoint location3 = [t3 locationInView: [t3 view]];
			CGPoint start3 = [[CCDirector sharedDirector] convertToGL:location3];
			CGPoint end3 = [t3 previousLocationInView:[t3 view]];
			end3 = [[CCDirector sharedDirector] convertToGL:end3];
			self.emitter3.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter3 = [CCPointParticleSystem particleWithFile:@"t3.plist"];
			self.emitter3.duration = .1;
			self.emitter3.position = ccp(start3.x,start3.y);
				//[self addChild: emitter3 z:0];
			
			
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.y]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.y]];
			[[self oscSender] sendOSCPacket:touch1];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.y]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.y]];
			[[self oscSender] sendOSCPacket:touch2];
			
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.y]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.y]];

			[[self oscSender] sendOSCPacket:touch3];
						
			
			
		} break;
			
		case 4: {
			
			[self removeChild:background cleanup:YES];
			background = nil;
			
			
			UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
			CGPoint location = [t1 locationInView: [t1 view]];
			CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
			CGPoint end = [t1 previousLocationInView:[t1 view]];
			end = [[CCDirector sharedDirector] convertToGL:end];
			self.emitter.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter = [CCPointParticleSystem particleWithFile:@"t1.plist"];
			self.emitter.duration = .1;
			self.emitter.position = ccp(start.x,start.y);
				//[self addChild: emitter z:0];
			
			
			
			UITouch *t2 = [[allTouches allObjects]objectAtIndex:1];
			CGPoint location2 = [t2 locationInView: [t2 view]];
			CGPoint start2 = [[CCDirector sharedDirector] convertToGL:location2];
			CGPoint end2 = [t2 previousLocationInView:[t2 view]];
			end2 = [[CCDirector sharedDirector] convertToGL:end2];
			self.emitter2.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter2 = [CCPointParticleSystem particleWithFile:@"t2.plist"];
			self.emitter2.duration =.1;
			self.emitter2.position = ccp(start2.x,start2.y);
				//[self addChild: emitter2 z:0];
			
			
			UITouch *t3 = [[allTouches allObjects]objectAtIndex:2];
			CGPoint location3 = [t3 locationInView: [t3 view]];
			CGPoint start3 = [[CCDirector sharedDirector] convertToGL:location3];
			CGPoint end3 = [t3 previousLocationInView:[t3 view]];
			end3 = [[CCDirector sharedDirector] convertToGL:end3];
			self.emitter3.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter3 = [CCPointParticleSystem particleWithFile:@"t3.plist"];
			self.emitter3.duration = .1;
			self.emitter3.position = ccp(start3.x,start3.y);
				//[self addChild: emitter3 z:0];
			
			UITouch *t4 = [[allTouches allObjects]objectAtIndex:3];
			CGPoint location4 = [t4 locationInView: [t4 view]];
			CGPoint start4 = [[CCDirector sharedDirector] convertToGL:location4];
			CGPoint end4 = [t4 previousLocationInView:[t4 view]];
			end4 = [[CCDirector sharedDirector] convertToGL:end4];
			self.emitter4.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter4 = [CCPointParticleSystem particleWithFile:@"t4.plist"];
			self.emitter4.duration = .1;
			self.emitter4.position = ccp(start4.x,start4.y);
				//[self addChild: emitter4 z:0];
			
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.y]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.y]];
			[[self oscSender] sendOSCPacket:touch1];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.y]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.y]];
			[[self oscSender] sendOSCPacket:touch2];
			
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.y]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.y]];
			
			[[self oscSender] sendOSCPacket:touch3];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:start4.x]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:start4.y]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:end4.x]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:end4.y]];
			[[self oscSender] sendOSCPacket:touch4];
			
			
			
		} break;
		case 5: {
			
			[self removeChild:background cleanup:YES];
			background = nil;
			
			
			UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
			CGPoint location = [t1 locationInView: [t1 view]];
			CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
			CGPoint end = [t1 previousLocationInView:[t1 view]];
			end = [[CCDirector sharedDirector] convertToGL:end];
			self.emitter.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter = [CCPointParticleSystem particleWithFile:@"t1.plist"];
			self.emitter.duration = .1;
			self.emitter.position = ccp(start.x,start.y);
				//[self addChild: emitter z:0];
			
			
			
			UITouch *t2 = [[allTouches allObjects]objectAtIndex:1];
			CGPoint location2 = [t2 locationInView: [t2 view]];
			CGPoint start2 = [[CCDirector sharedDirector] convertToGL:location2];
			CGPoint end2 = [t2 previousLocationInView:[t2 view]];
			end2 = [[CCDirector sharedDirector] convertToGL:end2];
			self.emitter2.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter2 = [CCPointParticleSystem particleWithFile:@"t2.plist"];
			self.emitter2.duration =.1;
			self.emitter2.position = ccp(start2.x,start2.y);
				//[self addChild: emitter2 z:0];
			
			
			UITouch *t3 = [[allTouches allObjects]objectAtIndex:2];
			CGPoint location3 = [t3 locationInView: [t3 view]];
			CGPoint start3 = [[CCDirector sharedDirector] convertToGL:location3];
			CGPoint end3 = [t3 previousLocationInView:[t3 view]];
			end3 = [[CCDirector sharedDirector] convertToGL:end3];
			self.emitter3.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter3 = [CCPointParticleSystem particleWithFile:@"t3.plist"];
			self.emitter3.duration = .1;
			self.emitter3.position = ccp(start3.x,start3.y);
				//[self addChild: emitter3 z:0];
			
			UITouch *t4 = [[allTouches allObjects]objectAtIndex:3];
			CGPoint location4 = [t4 locationInView: [t4 view]];
			CGPoint start4 = [[CCDirector sharedDirector] convertToGL:location4];
			CGPoint end4 = [t4 previousLocationInView:[t4 view]];
			end4 = [[CCDirector sharedDirector] convertToGL:end4];
			self.emitter4.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter4 = [CCPointParticleSystem particleWithFile:@"t4.plist"];
			self.emitter4.duration = .1;
			self.emitter4.position = ccp(start4.x,start4.y);
				//[self addChild: emitter4 z:0];
			
			UITouch *t5 = [[allTouches allObjects]objectAtIndex:4];
			CGPoint location5 = [t5 locationInView: [t4 view]];
			CGPoint start5 = [[CCDirector sharedDirector] convertToGL:location5];
			CGPoint end5 = [t5 previousLocationInView:[t5 view]];
			end5 = [[CCDirector sharedDirector] convertToGL:end5];
			self.emitter5.texture = [[CCTextureCache sharedTextureCache] addImage: @"fire.pvr"];
			self.emitter5 = [CCPointParticleSystem particleWithFile:@"t5.plist"];
			self.emitter5.duration = .1;
			self.emitter5.position = ccp(start5.x,start5.y);
				//	[self addChild: emitter5 z:0];
			
			
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:start.y]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.x]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:end.y]];
			[[self oscSender] sendOSCPacket:touch1];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:start2.y]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.x]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:end2.y]];
			[[self oscSender] sendOSCPacket:touch2];
			
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:start3.y]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.x]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:end3.y]];
			
			[[self oscSender] sendOSCPacket:touch3];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:start4.x]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:start4.y]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:end4.x]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:end4.y]];
			[[self oscSender] sendOSCPacket:touch4];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:start5.x]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:start5.y]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:end5.x]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:end5.y]];
			[[self oscSender] sendOSCPacket:touch5];
						
			
		} break;
			
		default:{
			
		
			
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[[self oscSender] sendOSCPacket:touch1];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[[self oscSender] sendOSCPacket:touch2];
			
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			
			[[self oscSender] sendOSCPacket:touch3];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[[self oscSender] sendOSCPacket:touch4];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
			[[self oscSender] sendOSCPacket:touch5];
			
		}break;
}
}


	

	
- (void)ccTouchesEnded:(NSSet *)touches withEvent:(UIEvent *)event;
{
	NSUInteger touchCount = 0;
	
	NSSet *allTouches = [event allTouches];
	
	for (UITouch *touch in touches) {
		touchCount++;}
	
	
	UITouch *t1 = [[allTouches allObjects]objectAtIndex:0];
	CGPoint location = [t1 locationInView: [t1 view]];
	CGPoint start = [[CCDirector sharedDirector] convertToGL:location];
		CGPoint pos = CGPointZero;
	touch1 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/1/"]];
	touch2 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/2/"]];
	touch3 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/3/"]];
	touch4 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/4/"]];
	touch5 = [BBOSCMessage messageWithBBOSCAddress:[BBOSCAddress addressWithString:@"/touch/5/"]];
	[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch1 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[[self oscSender] sendOSCPacket:touch1];
	[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch2 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[[self oscSender] sendOSCPacket:touch2];
	
	[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch3 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	
	[[self oscSender] sendOSCPacket:touch3];
	[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch4 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[[self oscSender] sendOSCPacket:touch4];
	[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[touch5 attachArgument:[BBOSCArgument argumentWithFloat:0]];
	[[self oscSender] sendOSCPacket:touch5];
	
	
	if( background )
	pos = [background convertToWorldSpace:CGPointZero];
	emitter.position = ccpSub(start, pos);
	
	if( background )
		pos = [background convertToWorldSpace:CGPointZero];
	emitter2.position = ccpSub(start, pos);
	
	if( background )
		pos = [background convertToWorldSpace:CGPointZero];
	emitter3.position = ccpSub(start, pos);
	
	if( background )
		pos = [background convertToWorldSpace:CGPointZero];
	emitter4.position = ccpSub(start, pos);
	
	if( background )
		pos = [background convertToWorldSpace:CGPointZero];
	emitter5.position = ccpSub(start, pos);
	
}



-(void) setEmitterPosition
{
	if( CGPointEqualToPoint( emitter.centerOfGravity, CGPointZero ) ) 
		emitter.position = ccp(512, 384);
	
	if( CGPointEqualToPoint( emitter2.centerOfGravity, CGPointZero ) ) 
		emitter2.position = ccp(512, 384);
	
	if( CGPointEqualToPoint( emitter3.centerOfGravity, CGPointZero ) ) 
		emitter3.position = ccp(512, 384);
	
	if( CGPointEqualToPoint( emitter4.centerOfGravity, CGPointZero ) ) 
		emitter4.position = ccp(512, 384);
	
	if( CGPointEqualToPoint( emitter5.centerOfGravity, CGPointZero ) ) 
		emitter5.position = ccp(512, 384);
	
	
}



- (void)accelerometer:(UIAccelerometer*)accelerometer didAccelerate:(UIAcceleration*)acceleration
{	
	static float prevX=0, prevY=0;
	
		//#define kFilterFactor 0.05f
#define kFilterFactor 1.0f
		// don't use filter. the code is here just as an example
	
	float accelX = (float) acceleration.x * kFilterFactor + (1- kFilterFactor)*prevX;
	float accelY = (float) acceleration.y * kFilterFactor + (1- kFilterFactor)*prevY;
	
	prevX = accelX;
	prevY = accelY;
	
	self.ax=prevX;
	self.ay=prevY;
	
	float randx = -3000 + rand()%3000;
	float randy = -3000 + rand()%3000;
	
	emitter.gravity = ccp(self.ay*randx/4 ,self.ax*randy*-1/4);
	
	emitter2.gravity = ccp(self.ay*randx/4 ,self.ax*randy*-1/4);
	
	emitter3.gravity = ccp(self.ay*randx/4 ,self.ax*randy*-1/4);
	
	emitter4.gravity = ccp(self.ay*randx/4 ,self.ax*randy*-1/4);
	
	emitter5.gravity = ccp(self.ay*randx/4 ,self.ax*randy*-1/4);

	
	
}


// on "dealloc" you need to release all your retained objects
- (void) dealloc
{
	[emitter release];
	[emitter2 release];
	[emitter3 release];
	[emitter4 release];
	[emitter5 release];

	[super dealloc];
}
@end
